LX  = 8.0e-06;
NX  = 4000;
rho = 0.5e-06;
nco = 1.45;
ncl = 1.00;
lam = 2000e-09;

cx  = linspace(-LX/2, +LX/2, 4000)/rho;

[Ex,Ey,Ez,bTE,bTM] = E_swg(cx,nco,ncl,rho,lam);

Ex = Ex/max(Ex);
Ey = Ey/max(Ey);

figure(1);
plot(cx*rho,Ex.^2);
hold on;
plot(cx*rho,Ey.^2,'r');

tab = zeros(NX,2);
tab(:,1) = cx*rho;
tab(:,2) = Ex.^2;

dlmwrite('ModeTM.tab',tab,' ');

tab(:,2) = Ey.^2;

dlmwrite('ModeTE.tab',tab,' ');

neffTM = bTM*lam/(2.0*pi);
neffTE = bTE*lam/(2.0*pi);

display(neffTM);
display(neffTE);
