#ifndef __bpm_utils_h__
#define __bpm_utils_h__

#include<complex>
#include<iostream>
#include<fstream>

using namespace std;
typedef complex<double> comple;

// for initial condition
comple gauss1D(double wr, double r, double z, double k, double f);

// to write amplitude array
void Save(const char *fname, int n, double *cx, comple *a);

// to write amplitude array with template
void Save(const char *fname, int n, double *cx, comple *a, comple *t);

// to write amplitude array and convert if from D to E
void SaveEField(const char *fname, int n, double *cx, comple *a, int b1, int b2, double e1, double e2);

// to be used after propagation in imaginary distance
void Normalize(comple *a, int n, double scale);

// tri-diagonal linear solver
void TDMsolver (int n, const comple *a, comple *b, const comple *c, comple *v, comple *x);

// right hand side discrtization for TM sub-problem
void SetRHS_TM(comple *ll, comple *lc, comple *lr, int n, int b1, int b2, double dx, double lambda, double nref, double epso, double epsc);

// right hand side discrtization for TM sub-problem
void SetRHS_TE(comple *ll, comple *lc, comple *lr, int n, int b1, int b2, double dx, double lambda, double nref, double epso, double epsc);


#endif // __bpm_utils_h__
